package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.CipherParameters;
import cn.com.infosec.crypto.Digest;
import cn.com.infosec.crypto.PBEParametersGenerator;
import cn.com.infosec.crypto.params.KeyParameter;
import cn.com.infosec.crypto.params.ParametersWithIV;

public class PKCS5S1ParametersGenerator extends PBEParametersGenerator {
   private Digest digest;

   public PKCS5S1ParametersGenerator(Digest digest) {
      this.digest = digest;
   }

   private byte[] generateDerivedKey() {
      int var1;
      byte[] var2 = new byte[var1 = this.digest.getDigestSize()];
      byte[] var10003 = super.password;
      this.digest.update(var10003, 0, var10003.length);
      byte[] var10002 = super.salt;
      this.digest.update(var10002, 0, var10002.length);
      this.digest.doFinal(var2, 0);

      for(int var3 = 1; var3 < super.iterationCount; ++var3) {
         this.digest.update(var2, 0, var1);
         this.digest.doFinal(var2, 0);
      }

      return var2;
   }

   public CipherParameters generateDerivedParameters(int keySize) {
      if ((keySize /= 8) <= this.digest.getDigestSize()) {
         byte[] var2 = this.generateDerivedKey();
         return new KeyParameter(var2, 0, keySize);
      } else {
         throw new IllegalArgumentException("Can't generate a derived key " + keySize + " bytes long.");
      }
   }

   public CipherParameters generateDerivedParameters(int keySize, int ivSize) {
      int var3;
      if ((var3 = (keySize /= 8) + (ivSize /= 8)) <= this.digest.getDigestSize()) {
         byte[] var4 = this.generateDerivedKey();
         KeyParameter var5;
         var5 = new KeyParameter.<init>(var4, 0, keySize);
         return new ParametersWithIV(var5, var4, keySize, ivSize);
      } else {
         throw new IllegalArgumentException("Can't generate a derived key " + var3 + " bytes long.");
      }
   }

   public CipherParameters generateDerivedMacParameters(int keySize) {
      return this.generateDerivedParameters(keySize);
   }
}
